/*==============================================
	DSSound.cpp
		DirectShowgTEh̍Đ
------------------------------------------------
	ҁFˑ
	F2011/10/17
==============================================*/

#include "DSSound.h"


//----------------------------------------------
// RXgN^
//----------------------------------------------
DSSound::DSSound()
{
	m_pGraphBuilder = NULL;
	m_pMediaControl = NULL;
	m_pMediaPosition = NULL;

	// tȌ
	isPlay		= false;
	isLoop		= false;
	isFadeIn	= false;
	isFadeOut	= false;
}

//----------------------------------------------
// fXgN^
//----------------------------------------------
DSSound::~DSSound()
{
	SetVolum(-10000);
	Sleep(13);
	Stop();
	SAFE_RELEASE(m_pMediaPosition);
	SAFE_RELEASE(m_pMediaControl);
	SAFE_RELEASE(m_pGraphBuilder);
	CoUninitialize();
}

//----------------------------------------------
// (ǂݍ)
//----------------------------------------------
int DSSound::Load(BSTR filePass,bool LoopFlg)
{
	CoInitialize(NULL);
	CoCreateInstance( CLSID_FilterGraph, NULL, CLSCTX_INPROC, IID_IGraphBuilder, (LPVOID *)&m_pGraphBuilder);
	
	m_pGraphBuilder->QueryInterface(IID_IMediaControl, (LPVOID *)&m_pMediaControl );
	m_pGraphBuilder->QueryInterface(IID_IMediaPosition, (LPVOID *)&m_pMediaPosition );
	
	m_pMediaControl->RenderFile( filePass );
	
	isLoop = LoopFlg;
	isPlay = false;
	isFadeIn = false;
	isFadeOut = false;
	isFadeStop = false;
	isFadePlay = false;

	SetVolum(0);

	return 0;
}


//----------------------------------------------
// I
//----------------------------------------------
int DSSound::DSUninit()
{
	return 0;
}

//----------------------------------------------
// Đ
//----------------------------------------------
int DSSound::Play()
{
	m_pMediaControl->Run();
	isPlay = true;
	isFadeIn = false;
	isFadeOut = false;
	isFadeStop = false;
	isFadePlay = false;
	SetVolum(0);
	return 0;
}

//----------------------------------------------
// Đ
//----------------------------------------------
int DSSound::PlayForced(bool LoopFlg)
{
	m_pMediaPosition->put_CurrentPosition(0);
	m_pMediaControl->Run();
	isPlay = true;
	
	return 0;
}

//----------------------------------------------
// ~
//----------------------------------------------
int DSSound::Stop()
{	
	// ~Oɉʂ
	m_pMediaControl->Stop();
	
	// 擪֖߂
	m_pMediaPosition->put_CurrentPosition(0);

	isPlay = false;

	isFadeIn = false;
	isFadeOut = false;
	isFadeStop = false;
	isFadePlay = false;

	return 0;
}

//----------------------------------------------
// ꎞ~
//----------------------------------------------
int DSSound::Pause()
{
	m_pMediaControl->Pause();
	
	isPlay = false;

	isFadeIn = false;
	isFadeOut = false;
	isFadeStop = false;
	isFadePlay = false;

	return 0;
}

//----------------------------------------------
// ꎞ~
//----------------------------------------------
int DSSound::Resume()
{
	return 0;
}

//----------------------------------------------
// [ṽ`FbN
//----------------------------------------------
int DSSound::LoopCheck()
{
	// tF[hC
	if(isFadeIn)
	{
		m_FICount+=1;
		long vol = (100 - m_FICount) * -100;
		SetVolum(vol);
		if(m_FICount == 100)
		{
			isFadeIn = false;
			return DS_FADEIN_END;
		}
	}

	// tF[hAEg
	if(isFadeOut)
	{
		m_FOCount+=1;
		long vol = m_FOCount * -100;
		SetVolum(vol);
		if(m_FOCount == 100)
		{
			isFadeOut = false;
			return DS_FADEOUT_END;
		}
	}

	// tF[hXgbv(tF[hAEg~)
	if(isFadeStop)
	{
		m_FSCount+=1;
		long vol = m_FSCount * -100;
		SetVolum(vol);
		if(m_FSCount == 100)
		{
			isFadeStop = false;
			Stop();
		}
	}

	// tF[hvC(tF[hCĐ)
	if(isFadePlay)
	{
		m_FPCount+=1;
		long vol = (100 - m_FPCount) * -100;
		SetVolum(vol);
		if(m_FPCount == 100)
		{
			isFadePlay = false;
		}
	}

	// [vȂꍇ͏I
	if ( !isPlay || !isLoop ) {return -1;}
	

	// [v
	REFTIME pos, end;
	m_pMediaPosition->get_CurrentPosition(&pos);
	m_pMediaPosition->get_StopTime(&end);
	if ( pos >= end ){	
		
		// x~Đ
		Stop();
		Play();
		return DS_LOOP_SET;
	}	
	return 0;
}

void DSSound::Release()
{

}

int DSSound::VolumMin()
{
	IBasicAudio *pBasicAudio;
	m_pGraphBuilder->QueryInterface(IID_IBasicAudio, (LPVOID *)&pBasicAudio );
	pBasicAudio->put_Volume(-10000);
	pBasicAudio->Release();
	return 0;
}
int DSSound::VolumMax()
{
	IBasicAudio *pBasicAudio;
	m_pGraphBuilder->QueryInterface(IID_IBasicAudio, (LPVOID *)&pBasicAudio );
	pBasicAudio->put_Volume(0);
	pBasicAudio->Release();
	return 0;
}
long DSSound::VolumNow()
{
	// ~Oɉʂ
	IBasicAudio *pBasicAudio;
	m_pGraphBuilder->QueryInterface(IID_IBasicAudio, (LPVOID *)&pBasicAudio );
	long vol = 0;
	pBasicAudio->get_Volume( &vol );
	pBasicAudio->Release();
	return vol;
}
int DSSound::SetVolum(long vol)
{
	// ~Oɉʂ
	IBasicAudio *pBasicAudio;
	m_pGraphBuilder->QueryInterface(IID_IBasicAudio, (LPVOID *)&pBasicAudio );
	pBasicAudio->put_Volume( vol );
	pBasicAudio->Release();
	return 0;
}

void DSSound::FadeIn()
{
	// tF[hłȂ
	if(!isFadeIn && !isFadeOut && !isFadeStop)
	{
		m_FICount = 0;
		isFadeIn = true;
	}
}

void DSSound::FadeOut()
{
	// tF[hłȂ
	if(!isFadeIn && !isFadeOut && !isFadeStop)
	{
		m_FOCount = 0;
		isFadeOut = true;
	}

}
void DSSound::FadeStop()
{
	// tF[hłȂ
	if(!isFadeIn && !isFadeOut && !isFadeStop && !isFadePlay)
	{
		m_FSCount = 0;
		isFadeStop = true;
	}
}

void DSSound::FadePlay()
{
	// tF[hłȂ
	if(!isFadeIn && !isFadeOut && !isFadeStop && !isFadePlay && !isPlay)
	{
		Play();
		VolumMin();
		m_FPCount = 0;
		isFadePlay = true;
	}
}
