/*==============================================
	SoundManager.cpp
		TEhǗNX
------------------------------------------------
	ҁFˑ
	F2011/10/18
==============================================*/

// CN[h
#include "SoundManager.h"

SoundManager* SoundManager::m_Instance = 0;	// CX^X

// RXgN^
SoundManager::SoundManager()
{	
	for(int i = 0; i < SOUND_BGM_MAX; i++)
	{
		m_pBGM[i] = NULL;
	}
	for(int i = 0; i < SOUND_SE_MAX; i++)
	{
		m_pSE[i] = NULL;
	}
}

// fXgN^
SoundManager::~SoundManager()
{
	for(int i = 0; i < SOUND_BGM_MAX; i++)
	{
		SAFE_DELETE(m_pBGM[i]);
	}
	for(int i = 0; i < SOUND_SE_MAX; i++)
	{
		SAFE_DELETE(m_pSE[i]);
	}
}

void SoundManager::Create()
{
	m_Instance = new SoundManager();

}

void SoundManager::Destroy()
{
	SAFE_DELETE(m_Instance);
}

void SoundManager::Update()
{
	for(int i = 0; i < SOUND_BGM_MAX; i++)
	{
		if(m_pBGM[i])
		{
			m_pBGM[i]->LoopCheck();
		}
	}
}


//----------------------------------------------
// BGM֘A
//----------------------------------------------

// BGMǂݍ
bool SoundManager:: LoadBGM(int num, BSTR filePass,bool loopFlg)
{
	// e͈͓Ȃΐ
	if(0 <= num && num < SOUND_BGM_MAX)
	{
		// łɃCX^XĂꍇ
		if(m_pBGM[num])
		{
			// ~
			m_pBGM[num]->Stop();

			// CX^Xj
			SAFE_DELETE(m_pBGM[num]);

			// CX^X
			m_pBGM[num] = new DSSound();

			// ǂݍ
			m_pBGM[num]->Load((BSTR)filePass,loopFlg);

			if(!m_pBGM[num])
			{
				return false;
			}

		}
		else
		{		
			// CX^X
			m_pBGM[num] = new DSSound();

			// ǂݍ
			m_pBGM[num]->Load((BSTR)filePass,loopFlg);

			if(!m_pBGM[num])
			{
				return false;
			}
		}
	}
	return true;
}

// BGM
void SoundManager::ReleaseBGM(int num)
{
	// CX^Xj
	SAFE_DELETE(m_pBGM[num]);

}

void SoundManager::PlayBGM(int num)
{
	// e͈͓Ȃΐ
	if(0 <= num && num < SOUND_BGM_MAX)
	{
		// t@Cǂݍ܂Ă
		if(m_pBGM[num])
			m_pBGM[num]->Play();
	}

}
void SoundManager::StopBGM(int num)
{
	// e͈͓Ȃΐ
	if(0 <= num && num < SOUND_BGM_MAX)
	{
		// t@Cǂݍ܂Ă
		if(m_pBGM[num])
			m_pBGM[num]->Stop();
	}

}
void SoundManager::PauseBGM(int num)
{
	// e͈͓Ȃ
	if(0 <= num && num < SOUND_BGM_MAX)
	{
		// t@Cǂݍ܂Ă
		if(m_pBGM[num])
		{
			m_pBGM[num]->Pause();
		}
	}

}

//----------------------------------------------
// NXtF[h
//----------------------------------------------
void SoundManager::CrossFade(int in, int out)
{
	// Ă΁EEE
	if((0 <= in && in < SOUND_BGM_MAX) &&
		(0 <= out && out < SOUND_BGM_MAX) &&
		(in != out) && 
		(m_pBGM[in] && m_pBGM[out]) &&
		(!m_pBGM[in]->IsPlay() && m_pBGM[out]->IsPlay()))
	{
		m_pBGM[in]->FadePlay();
		m_pBGM[out]->FadeStop();
	}
}
void SoundManager::FadeOutBGM(int num)
{	
	// e͈͓Ȃ
	if(0 <= num && num < SOUND_BGM_MAX)
	{
		// t@Cǂݍ܂Ă
		if(m_pBGM[num])
		{
			m_pBGM[num]->FadeOut();
		}
	}
}
void SoundManager::FadeInBGM(int num)
{
	// e͈͓Ȃ
	if(0 <= num && num < SOUND_BGM_MAX)
	{
		// t@Cǂݍ܂Ă
		if(m_pBGM[num])
		{
			m_pBGM[num]->FadeIn();
		}
	}
}
void SoundManager::FadePlayBGM(int num)
{
	// e͈͓Ȃ
	if(0 <= num && num < SOUND_BGM_MAX)
	{
		// t@Cǂݍ܂Ă
		if(m_pBGM[num])
		{
			m_pBGM[num]->FadePlay();
		}
	}
}

void SoundManager::FadeStopBGM(int num)
{
	// e͈͓Ȃ
	if(0 <= num && num < SOUND_BGM_MAX)
	{
		// t@Cǂݍ܂Ă
		if(m_pBGM[num])
		{
			m_pBGM[num]->FadeStop();
		}
	}
}

void SoundManager::SetVolumeBGM(int num , long vol)
{
	// e͈͓Ȃΐ
	if(0 <= num && num < SOUND_BGM_MAX)
	{
		// t@Cǂݍ܂Ă
		if(m_pBGM[num])
			m_pBGM[num]->SetVolum(vol);
	}
}

	
// SE֘A
bool SoundManager:: LoadSE(int num,BSTR filePass)
{
	// e͈͓Ȃΐ
	if(0 <= num && num < SOUND_SE_MAX)
	{
		// łɃCX^XĂꍇ
		if(m_pSE[num])
		{
			// ~
			m_pSE[num]->Stop();

			// CX^Xj
			SAFE_DELETE(m_pSE[num]);

			// CX^X
			m_pSE[num] = new DirectSound();
			

			// ǂݍ
			if(!m_pSE[num]->Load((BSTR)filePass))
			{
				SAFE_DELETE(m_pSE[num]);
				return false;
			}

		}
		else
		{		
			// CX^X
			m_pSE[num] = new DirectSound();

			// ǂݍ
			if(!m_pSE[num]->Load((BSTR)filePass))
			{
				SAFE_DELETE(m_pSE[num]);
				return false;
			}
		}
	}
	return true;
}

void SoundManager::ReleaseSE(int num)
{
	// e͈͓Ȃΐ
	if(0 <= num && num < SOUND_SE_MAX)
	{
		SAFE_DELETE(m_pSE[num]);
	}
}

void SoundManager::PlaySE(int num)
{
	// e͈͓Ȃΐ
	if(0 <= num && num < SOUND_SE_MAX)
	{
		// ǂݍ܂Ă
		if(m_pSE[num])
		{
			m_pSE[num]->Play();
		}
	}
}
void SoundManager:: StopSE(int num)
{
	// e͈͓Ȃΐ
	if(0 <= num && num < SOUND_SE_MAX)
	{
		// ǂݍ܂Ă
		if(m_pSE[num])
		{
			m_pSE[num]->Stop();
		}
	}

}