/*==============================================
	SoundManager.h
		TEhǗNX
------------------------------------------------
	ҁFˑ
	F2011/10/18
==============================================*/

#ifndef _INCLUDE_SOUNDMANAGER_H_
#define _INCLUDE_SOUNDMANAGER_H_

#include "../Framework/Framework.h"

#include "DSSound.h"
#include "DirectSound.h"

enum eSEState{
	SE_WALK = 0,
	SE_JUMP = 1,
	SE_CALL = 2,
	SE_WIP	= 3,
	SE_HIT	= 4,

	// ^Cg
	SE_DECIDE = 5,
	SE_SELECT = 6,

	// Q[I[o[
	SE_GAMEOVER	   = 7,

	// LN^[
	SE_CHARAACTION_WHISTLE = 8,
	SE_CHARA_JOINT		   = 9,
	SE_CHARA_TACKLE		   = 10,
	SE_CHARA_DUSH		   = 11,
	SE_CHARA_SPIN		   = 12,
	SE_CHARA_WIP		   = 13,
	SE_CHARA_TAKEDAMAGE	   = 14,
	SE_CHARA_LASTDAMAGE	   = 15,
	SE_CHARA_JOINTVOICE	   = 16,


	// G
	SE_ENEMY_BLOW		   = 17,
	SE_ENEMY_A_ATTACK      = 18,
	SE_ENEMY_A_EAT		   = 19,
	SE_ENEMY_B_SMALLJUMP   = 20,
	SE_ENEMY_B_BIGJUMP     = 21,
	SE_ENEMY_FLY	       = 22,

	
	// ReBj[
	SE_CONTINUE_SELECT = 23,
	SE_CONTINUE_DESIDE = 24,

	// {X
	SE_BOSS_QUAKE = 25,
	SE_BOSS_CRUSH = 26,
	SE_BOSS_SEIZE = 27,
	SE_BOSS_EAT = 28,
	SE_BOSS_TAKEDAMAGE = 29,
	SE_BOSS_VOICE = 30,
	SE_BOSS_DEATHVOICE = 31,
	SE_BOSS_TAKE_LASTATTACK = 32,
	SE_BOSS_POLE = 33,
	
	// Xe[W
	SE_ROCKBREAK = 34,
	SE_ONTOROCK = 35,

	// ACe擾
	SE_GETITEM = 36,

	// Xg[[
	SE_STORYPAGE = 37,

	SE_MAXNUM

};

// `
const int SOUND_BGM_MAX		= 8;		// BGMő吔
const int SOUND_SE_MAX		= SE_MAXNUM;		// SEő吔

class SoundManager{
private:
	DSSound*		m_pBGM[SOUND_BGM_MAX];	// DirectShowf[^
	DirectSound*	m_pSE[SOUND_SE_MAX];	// DirectSoundf[^
	
	SoundManager();		// RXgN^
	~SoundManager();	// fXgN^
	static SoundManager* m_Instance;	// CX^X
public:
	static SoundManager* Instance(){return m_Instance;}
	static void Create();	// CX^X
	static void Destroy();	// CX^X

	void Update();

	// BGM֘A
	bool LoadBGM(int num, BSTR filePass, bool loopFlg);		// BGMǂݍ
	void ReleaseBGM(int num);				// BGM
	void PlayBGM(int num);					// BGMĐ
	void StopBGM(int num);					// BGM~
	void PauseBGM(int num);					// BGMꎞ~
	void CrossFade(int in, int out);		// BGMNXtF[h
	void FadeOutBGM(int num);				// BGMtF[hAEg
	void FadeInBGM(int num);				// BGMtF[hC
	void FadeStopBGM(int num);				// BGMtF[hAEg~
	void FadePlayBGM(int num);				// BGMĐtF[hC
	void SetVolumeBGM(int num,long vol);	// BGMʐݒ
	
	// SE֘A
	bool LoadSE(int num,BSTR filePass);		// SEǂݍ
	void ReleaseSE(int num);
	void PlaySE(int num);					// SEĐ
	void StopSE(int num);					// SE~
};

#endif // _INCLUDE_SOUNDMANAGER_H_